alter table acknowledges modify message         nvarchar2(255)          DEFAULT '';
CREATE INDEX actions_1 on actions (eventsource,status);

alter table actions modify name            nvarchar2(255)          DEFAULT '';
alter table actions modify def_shortdata           nvarchar2(255)          DEFAULT '';
alter table actions modify def_longdata            nvarchar2(2048)         DEFAULT '';
alter table actions modify r_shortdata             nvarchar2(255)          DEFAULT '';
alter table actions modify r_longdata              nvarchar2(2048)         DEFAULT '';

alter table alerts modify sendto          nvarchar2(100)          DEFAULT '';
alter table alerts modify subject         nvarchar2(255)          DEFAULT '';
alter table alerts modify message         nvarchar2(2048)         DEFAULT '';
alter table alerts modify error           nvarchar2(128)          DEFAULT '';
alter table applications modify name            nvarchar2(255)          DEFAULT '';
CREATE TABLE auditlog_details (
        auditdetailid           number(20)              DEFAULT '0'     NOT NULL,
        auditid         number(20)              DEFAULT '0'     NOT NULL,
        table_name              nvarchar2(64)           DEFAULT ''      ,
        field_name              nvarchar2(64)           DEFAULT ''      ,
        oldvalue                nvarchar2(2048)         DEFAULT ''      ,
        newvalue                nvarchar2(2048)         DEFAULT ''      ,
        PRIMARY KEY (auditdetailid)
);
CREATE INDEX auditlog_details_1 on auditlog_details (auditid);
alter table auditlog add ip nvarchar2(39)           DEFAULT '';
alter table auditlog add resourceid              number(20)              DEFAULT '0'     NOT NULL;
alter table auditlog add resourcename            nvarchar2(255)          DEFAULT '';

alter table auditlog modify details         nvarchar2(128)          DEFAULT '0';
CREATE TABLE autoreg_host (
        autoreg_hostid          number(20)              DEFAULT '0'     NOT NULL,
        proxy_hostid            number(20)              DEFAULT '0'     NOT NULL,
        host            nvarchar2(64)           DEFAULT ''      ,
        PRIMARY KEY (autoreg_hostid)
);
CREATE UNIQUE INDEX autoreg_host_1 on autoreg_host (proxy_hostid,host);
alter table conditions modify value           nvarchar2(255)          DEFAULT '';
alter table config add dropdown_first_entry number(10) DEFAULT '1' NOT NULL;
alter table config add dropdown_first_remember number(10) DEFAULT '1' NOT NULL;
alter table config add discovery_groupid number(20) DEFAULT '0' NOT NULL;
alter table config add max_in_table number(10) DEFAULT '50' NOT NULL;
alter table config add search_limit number(10) DEFAULT '1000' NOT NULL;


alter table config modify work_period             nvarchar2(100)          DEFAULT '1-5,00:00-24:00';
alter table config modify default_theme           nvarchar2(128)          DEFAULT 'default.css';
alter table config modify ldap_host               nvarchar2(255)          DEFAULT '';
alter table config modify ldap_base_dn            nvarchar2(255)          DEFAULT '';
alter table config modify ldap_bind_dn            nvarchar2(255)          DEFAULT '';
alter table config modify ldap_bind_password              nvarchar2(128)          DEFAULT '';
alter table config modify ldap_search_attribute           nvarchar2(128)          DEFAULT '';
alter table dchecks add snmpv3_securityname             nvarchar2(64)           DEFAULT '';
alter table dchecks add snmpv3_securitylevel            number(10)              DEFAULT '0'     NOT NULL;
alter table dchecks add snmpv3_authpassphrase           nvarchar2(64)           DEFAULT '';
alter table dchecks add snmpv3_privpassphrase           nvarchar2(64)           DEFAULT '';

CREATE INDEX dchecks_1 on dchecks (druleid);

alter table dchecks modify key_            nvarchar2(255)          DEFAULT '0';
alter table dchecks modify snmp_community          nvarchar2(255)          DEFAULT '0';
alter table dchecks modify ports           nvarchar2(255)          DEFAULT '0';
alter table dservices add dcheckid                number(20)              DEFAULT '0'     NOT NULL;
alter table dservices add ip              nvarchar2(39)           DEFAULT '';

update dservices set ip=(select dhosts.ip from dhosts where dservices.dhostid=dhosts.dhostid);

alter table dhosts drop column ip;

CREATE INDEX dhosts_1 on dhosts (druleid);

alter table drules add unique_dcheckid number(20) DEFAULT '0' NOT NULL;

alter table drules modify name            nvarchar2(255)          DEFAULT '';
alter table drules modify iprange         nvarchar2(255)          DEFAULT '';
-- See also dhosts.sql

CREATE UNIQUE INDEX dservices_1 on dservices (dcheckid,type,key_,ip,port);
CREATE INDEX dservices_2 on dservices (dhostid);

alter table dservices modify key_            nvarchar2(255)          DEFAULT '0';
alter table dservices modify value           nvarchar2(255)          DEFAULT '0';
alter table dservices modify ip              nvarchar2(39)           DEFAULT '';

CREATE INDEX escalations_2 on escalations (status,nextcheck);
DROP INDEX events_2;
CREATE INDEX events_2 on events (clock, objectid);
CREATE TABLE expressions (
        expressionid            number(20)              DEFAULT '0'     NOT NULL,
        regexpid                number(20)              DEFAULT '0'     NOT NULL,
        expression              nvarchar2(255)          DEFAULT ''      ,
        expression_type         number(10)              DEFAULT '0'     NOT NULL,
        exp_delimiter           nvarchar2(1)            DEFAULT ''      ,
        case_sensitive          number(10)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (expressionid)
);
CREATE INDEX expressions_1 on expressions (regexpid);

alter table functions modify lastvalue               nvarchar2(255);
alter table functions modify function                nvarchar2(12);
alter table functions modify parameter               nvarchar2(255);

CREATE TABLE globalmacro (
        globalmacroid           number(20)              DEFAULT '0'     NOT NULL,
        macro           nvarchar2(64)           DEFAULT ''      ,
        value           nvarchar2(255)          DEFAULT ''      ,
        PRIMARY KEY (globalmacroid)
);
CREATE INDEX globalmacro_1 on globalmacro (macro);
alter table graphs_items modify color           nvarchar2(6)            DEFAULT '009600';

CREATE INDEX graphs_items_1 on graphs_items (itemid);
CREATE INDEX graphs_items_2 on graphs_items (graphid);

alter table graphs_items modify color           nvarchar2(6)            DEFAULT '009600';
alter table graphs add ymin_type               number(10)              DEFAULT '0'     NOT NULL;
alter table graphs add ymax_type               number(10)              DEFAULT '0'     NOT NULL;
alter table graphs add ymin_itemid             number(20)              DEFAULT '0'     NOT NULL;
alter table graphs add ymax_itemid             number(20)              DEFAULT '0'     NOT NULL;

update graphs set ymin_type=yaxistype;
update graphs set ymax_type=yaxistype;

alter table graphs drop column yaxistype;

alter table graphs modify name            nvarchar2(128)          DEFAULT '';
CREATE TABLE graph_theme (
        graphthemeid            number(20)              DEFAULT '0'     NOT NULL,
        description             nvarchar2(64)           DEFAULT ''      ,
        theme           nvarchar2(64)           DEFAULT ''      ,
        backgroundcolor         nvarchar2(6)            DEFAULT 'F0F0F0'        ,
        graphcolor              nvarchar2(6)            DEFAULT 'FFFFFF'        ,
        graphbordercolor                nvarchar2(6)            DEFAULT '222222'        ,
        gridcolor               nvarchar2(6)            DEFAULT 'CCCCCC'        ,
        maingridcolor           nvarchar2(6)            DEFAULT 'AAAAAA'        ,
        gridbordercolor         nvarchar2(6)            DEFAULT '000000'        ,
        textcolor               nvarchar2(6)            DEFAULT '202020'        ,
        highlightcolor          nvarchar2(6)            DEFAULT 'AA4444'        ,
        leftpercentilecolor             nvarchar2(6)            DEFAULT '11CC11'        ,
        rightpercentilecolor            nvarchar2(6)            DEFAULT 'CC1111'        ,
        noneworktimecolor               nvarchar2(6)            DEFAULT 'E0E0E0'        ,
        gridview                number(10)              DEFAULT 1       NOT NULL,
        legendview              number(10)              DEFAULT 1       NOT NULL,
        PRIMARY KEY (graphthemeid)
);
CREATE INDEX graph_theme_1 on graph_theme (description);
CREATE INDEX graph_theme_2 on graph_theme (theme);

INSERT INTO graph_theme VALUES (1,'Original Blue','css_ob.css','F0F0F0','FFFFFF','333333','CCCCCC','AAAAAA','000000','222222','AA4444','11CC11','CC1111','E0E0E0',1,1);
INSERT INTO graph_theme VALUES (2,'Black & Blue','css_bb.css','333333','0A0A0A','888888','222222','4F4F4F','EFEFEF','0088FF','CC4444','1111FF','FF1111','1F1F1F',1,1);
alter table groups add internal                number(10)         DEFAULT '0'     NOT NULL;

alter table groups modify name            nvarchar2(64)           DEFAULT '';
alter table help_items modify key_            nvarchar2(255)          DEFAULT '';
alter table help_items modify description             nvarchar2(255)          DEFAULT '';
alter table history_log add logeventid              number(10)         DEFAULT '0'     NOT NULL;

CREATE TABLE history_log_tmp (
        id              number(20)              DEFAULT '0'     NOT NULL,
        itemid          number(20)              DEFAULT '0'     NOT NULL,
        clock           number(10)              DEFAULT '0'     NOT NULL,
        timestamp               number(10)              DEFAULT '0'     NOT NULL,
        source          nvarchar2(64)           DEFAULT ''      ,
        severity                number(10)              DEFAULT '0'     NOT NULL,
        value           nclob           DEFAULT ''      ,
        logeventid              number(10)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (id)
);


insert into history_log_tmp select * from history_log;
drop table history_log;

alter table history_log_tmp rename to history_log;

CREATE INDEX history_log_1 on history_log (itemid,clock);
CREATE UNIQUE INDEX history_log_2 on history_log (itemid,id);

alter table history_str modify value           nvarchar2(255)          DEFAULT '';
alter table history_str_sync modify value           nvarchar2(255)          DEFAULT '';

CREATE TABLE history_text_tmp (
        id              number(20)              DEFAULT '0'     NOT NULL,
        itemid          number(20)              DEFAULT '0'     NOT NULL,
        clock           number(10)              DEFAULT '0'     NOT NULL,
        value           nclob           DEFAULT ''      ,
        PRIMARY KEY (id)
);

insert into history_text_tmp select * from history_text;
drop table history_text;

alter table history_text_tmp rename to history_text;

CREATE INDEX history_text_1 on history_text (itemid,clock);
CREATE UNIQUE INDEX history_text_2 on history_text (itemid,id);
CREATE TABLE hostmacro (
        hostmacroid             number(20)              DEFAULT '0'     NOT NULL,
        hostid          number(20)              DEFAULT '0'     NOT NULL,
        macro           nvarchar2(64)           DEFAULT ''      ,
        value           nvarchar2(255)          DEFAULT ''      ,
        PRIMARY KEY (hostmacroid)
);
CREATE INDEX hostmacro_1 on hostmacro (hostid,macro);

drop index hosts_groups_groups_1;
CREATE INDEX hosts_groups_1 on hosts_groups (hostid,groupid);
CREATE INDEX hosts_groups_2 on hosts_groups (groupid);
alter table hosts_profiles_ext modify device_alias            nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_type             nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_chassis          nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_os               nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_os_short         nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_hw_arch          nvarchar2(32)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_serial           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_model            nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_tag              nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_vendor           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_contract         nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_who              nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_status           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_app_01           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_app_02           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_app_03           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_app_04           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_app_05           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify device_url_1            nvarchar2(255)          DEFAULT ''  ;
alter table hosts_profiles_ext modify device_url_2            nvarchar2(255)          DEFAULT ''  ;
alter table hosts_profiles_ext modify device_url_3            nvarchar2(255)          DEFAULT ''  ;
alter table hosts_profiles_ext modify device_networks         nvarchar2(2048)         DEFAULT ''  ;
alter table hosts_profiles_ext modify device_notes            nvarchar2(2048)         DEFAULT ''  ;
alter table hosts_profiles_ext modify device_hardware         nvarchar2(2048)         DEFAULT ''  ;
alter table hosts_profiles_ext modify device_software         nvarchar2(2048)         DEFAULT ''  ;
alter table hosts_profiles_ext modify ip_subnet_mask          nvarchar2(39)           DEFAULT ''  ;
alter table hosts_profiles_ext modify ip_router               nvarchar2(39)           DEFAULT ''  ;
alter table hosts_profiles_ext modify ip_macaddress           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify oob_ip          nvarchar2(39)           DEFAULT ''  ;
alter table hosts_profiles_ext modify oob_subnet_mask         nvarchar2(39)           DEFAULT ''  ;
alter table hosts_profiles_ext modify oob_router              nvarchar2(39)           DEFAULT ''  ;
alter table hosts_profiles_ext modify date_hw_buy             nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify date_hw_install         nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify date_hw_expiry          nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify date_hw_decomm          nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify site_street_1           nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify site_street_2           nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify site_street_3           nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify site_city               nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify site_state              nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify site_country            nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify site_zip                nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify site_rack               nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify site_notes              nvarchar2(2048)         DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_1_name              nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_1_email             nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_1_phone_1           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_1_phone_2           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_1_cell              nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_1_screen            nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_1_notes             nvarchar2(2048)         DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_2_name              nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_2_email             nvarchar2(128)          DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_2_phone_1           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_2_phone_2           nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_2_cell              nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_2_screen            nvarchar2(64)           DEFAULT ''  ;
alter table hosts_profiles_ext modify poc_2_notes             nvarchar2(2048)         DEFAULT ''  ;

alter table hosts_profiles modify devicetype              nvarchar2(64)           DEFAULT '';
alter table hosts_profiles modify name            nvarchar2(64)           DEFAULT '';
alter table hosts_profiles modify os              nvarchar2(64)           DEFAULT '';
alter table hosts_profiles modify serialno                nvarchar2(64)           DEFAULT '';
alter table hosts_profiles modify tag             nvarchar2(64)           DEFAULT '';
alter table hosts_profiles modify macaddress              nvarchar2(64)           DEFAULT '';
alter table hosts_profiles modify hardware                nvarchar2(2048)         DEFAULT '';
alter table hosts_profiles modify software                nvarchar2(2048)         DEFAULT '';
alter table hosts_profiles modify contact         nvarchar2(2048)         DEFAULT '';
alter table hosts_profiles modify location                nvarchar2(2048)         DEFAULT '';
alter table hosts_profiles modify notes           nvarchar2(2048)         DEFAULT '';
alter table hosts add maintenanceid number(20) DEFAULT '0' NOT NULL;
alter table hosts add maintenance_status number(10) DEFAULT '0' NOT NULL;
alter table hosts add maintenance_type number(10) DEFAULT '0' NOT NULL;
alter table hosts add maintenance_from number(10) DEFAULT '0' NOT NULL;
alter table hosts add ipmi_ip nvarchar2(64) DEFAULT '127.0.0.1' NOT NULL;
alter table hosts add ipmi_errors_from number(10) DEFAULT '0' NOT NULL;
alter table hosts add snmp_errors_from number(10) DEFAULT '0' NOT NULL;
alter table hosts add ipmi_error nvarchar2(128) DEFAULT '' NOT NULL;
alter table hosts add snmp_error nvarchar2(128) DEFAULT '' NOT NULL;

alter table hosts modify host            nvarchar2(64)           DEFAULT '';
alter table hosts modify dns             nvarchar2(64)           DEFAULT '';
alter table hosts modify ip              nvarchar2(39)           DEFAULT '127.0.0.1';
alter table hosts modify error           nvarchar2(128)          DEFAULT '';
alter table hosts modify ipmi_username           nvarchar2(16)           DEFAULT '';
alter table hosts modify ipmi_password           nvarchar2(20)           DEFAULT '';
alter table hosts modify ipmi_ip         nvarchar2(64)           DEFAULT '127.0.0.1';

alter table housekeeper modify tablename               nvarchar2(64)           DEFAULT '';
alter table housekeeper modify field           nvarchar2(64)           DEFAULT '';
alter table httpstep modify name            nvarchar2(64)           DEFAULT '';
alter table httpstep modify url             nvarchar2(255)          DEFAULT '';
alter table httpstep modify posts           nvarchar2(2048)         DEFAULT '';
alter table httpstep modify required                nvarchar2(255)          DEFAULT '';
alter table httpstep modify status_codes            nvarchar2(255)          DEFAULT '';
alter table httptest add authentication          number(10)         DEFAULT '0'     NOT NULL;
alter table httptest add http_user               nvarchar2(64)             DEFAULT ''      NOT NULL;
alter table httptest add http_password           nvarchar2(64)             DEFAULT ''      NOT NULL;

CREATE INDEX httptest_2 on httptest (name);
CREATE INDEX httptest_3 on httptest (status);

alter table httptest modify name            nvarchar2(64)           DEFAULT '';
alter table httptest modify macros          nvarchar2(2048)         DEFAULT '';
alter table httptest modify agent           nvarchar2(255)          DEFAULT '';
alter table httptest modify error           nvarchar2(255)          DEFAULT '';
alter table ids modify table_name              nvarchar2(64)           DEFAULT '';
alter table ids modify field_name              nvarchar2(64)           DEFAULT '';

alter table images modify name            nvarchar2(64)           DEFAULT '0';

alter table items drop column nextcheck;
alter table items add data_type  number(10)     DEFAULT '0' NOT NULL;
alter table items add authtype   number(10)     DEFAULT '0' NOT NULL;
alter table items add username   nvarchar2(64) DEFAULT ''  NOT NULL;
alter table items add password   nvarchar2(64) DEFAULT ''  NOT NULL;
alter table items add publickey  nvarchar2(64) DEFAULT ''  NOT NULL;
alter table items add privatekey nvarchar2(64) DEFAULT ''  NOT NULL;
alter table items add mtime      number(10)     DEFAULT '0' NOT NULL;

alter table items modify snmp_community          nvarchar2(64)           DEFAULT '';
alter table items modify snmp_oid                nvarchar2(255)          DEFAULT '';
alter table items modify description             nvarchar2(255)          DEFAULT '';
alter table items modify key_            nvarchar2(255)          DEFAULT '';
alter table items modify lastvalue               nvarchar2(255);
alter table items modify prevvalue               nvarchar2(255);
alter table items modify trapper_hosts           nvarchar2(255);
alter table items modify units           nvarchar2(10);
alter table items modify prevorgvalue            nvarchar2(255);
alter table items modify snmpv3_securityname             nvarchar2(64);
alter table items modify snmpv3_authpassphrase           nvarchar2(64);
alter table items modify snmpv3_privpassphrase           nvarchar2(64);
alter table items modify formula         nvarchar2(255)          DEFAULT '1';
alter table items modify error           nvarchar2(128)          DEFAULT '';
alter table items modify logtimefmt              nvarchar2(64)           DEFAULT '';
alter table items modify delay_flex              nvarchar2(255)          DEFAULT '';
alter table items modify params          nvarchar2(2048)         DEFAULT '';
alter table items modify ipmi_sensor             nvarchar2(128)          DEFAULT '';
CREATE TABLE maintenances_groups (
        maintenance_groupid             number(20)              DEFAULT '0'     NOT NULL,
        maintenanceid           number(20)              DEFAULT '0'     NOT NULL,
        groupid         number(20)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (maintenance_groupid)
);
CREATE INDEX maintenances_groups_1 on maintenances_groups (maintenanceid,groupid);

CREATE TABLE maintenances_hosts (
        maintenance_hostid              number(20)              DEFAULT '0'     NOT NULL,
        maintenanceid           number(20)              DEFAULT '0'     NOT NULL,
        hostid          number(20)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (maintenance_hostid)
);
CREATE INDEX maintenances_hosts_1 on maintenances_hosts (maintenanceid,hostid);

CREATE TABLE maintenances (
        maintenanceid           number(20)              DEFAULT '0'     NOT NULL,
        name            nvarchar2(128)          DEFAULT ''      ,
        maintenance_type                number(10)              DEFAULT '0'     NOT NULL,
        description             nvarchar2(2048)         DEFAULT ''      ,
        active_since            number(10)              DEFAULT '0'     NOT NULL,
        active_till             number(10)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (maintenanceid)
);
CREATE INDEX maintenances_1 on maintenances (active_since,active_till);

CREATE TABLE maintenances_windows (
        maintenance_timeperiodid                number(20)              DEFAULT '0'     NOT NULL,
        maintenanceid           number(20)              DEFAULT '0'     NOT NULL,
        timeperiodid            number(20)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (maintenance_timeperiodid)
);
CREATE INDEX maintenances_windows_1 on maintenances_windows (maintenanceid,timeperiodid);

alter table mappings modify value           nvarchar2(64)           DEFAULT '';
alter table mappings modify newvalue                nvarchar2(64)           DEFAULT '';

alter table media modify sendto          nvarchar2(100)          DEFAULT '';
alter table media modify period          nvarchar2(100)          DEFAULT '1-7,00:00-23:59';

alter table media_type modify description             nvarchar2(100)          DEFAULT '';
alter table media_type modify smtp_server             nvarchar2(255)          DEFAULT '';
alter table media_type modify smtp_helo               nvarchar2(255)          DEFAULT '';
alter table media_type modify smtp_email              nvarchar2(255)          DEFAULT '';
alter table media_type modify exec_path               nvarchar2(255)          DEFAULT '';
alter table media_type modify gsm_modem               nvarchar2(255)          DEFAULT '';
alter table media_type modify username                nvarchar2(255)          DEFAULT '';
alter table media_type modify passwd          nvarchar2(255)          DEFAULT '';

CREATE TABLE node_cksum_tmp (
        nodeid          number(10)              DEFAULT '0'     NOT NULL,
        tablename               nvarchar2(64)           DEFAULT ''      ,
        recordid                number(20)              DEFAULT '0'     NOT NULL,
        cksumtype               number(10)              DEFAULT '0'     NOT NULL,
        cksum           nclob           DEFAULT ''      ,
        sync            nvarchar2(128)          DEFAULT ''
);

insert into node_cksum_tmp select * from node_cksum;

drop table node_cksum;

alter table node_cksum_tmp rename to node_cksum;

CREATE INDEX node_cksum_cksum_1 on node_cksum (nodeid,tablename,recordid,cksumtype);
alter table nodes modify name            nvarchar2(64)           DEFAULT '0';
alter table nodes modify ip              nvarchar2(39)           DEFAULT '';
alter table opconditions modify value           nvarchar2(255)          DEFAULT '';
alter table operations modify shortdata               nvarchar2(255)          DEFAULT '';
alter table operations modify longdata                nvarchar2(2048)         DEFAULT '';

CREATE TABLE opmediatypes (
        opmediatypeid           number(20)              DEFAULT '0'     NOT NULL,
        operationid             number(20)              DEFAULT '0'     NOT NULL,
        mediatypeid             number(20)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (opmediatypeid)
);
CREATE UNIQUE INDEX opmediatypes_1 on opmediatypes (operationid);

CREATE INDEX profiles_2 on profiles (userid,profileid);

alter table profiles modify idx             nvarchar2(96)           DEFAULT '';
alter table profiles modify value_str               nvarchar2(255)          DEFAULT '';
alter table profiles modify source          nvarchar2(96)           DEFAULT '';

CREATE TABLE proxy_autoreg_host (
        id              number(20)                      NOT NULL,
        clock           number(10)              DEFAULT '0'     NOT NULL,
        host            nvarchar2(64)           DEFAULT ''      ,
        PRIMARY KEY (id)
);
CREATE INDEX proxy_autoreg_host_1 on proxy_autoreg_host (clock);

alter table proxy_dhistory modify key_            nvarchar2(255)            DEFAULT ''      NOT NULL;
alter table proxy_dhistory modify value           nvarchar2(255)            DEFAULT ''      NOT NULL;

alter table proxy_dhistory add         dcheckid                number(20)         DEFAULT '0'     NOT NULL;

alter table proxy_dhistory modify ip            nvarchar2(39)            DEFAULT ''      NOT NULL;
alter table proxy_history add logeventid              number(10)         DEFAULT '0'     NOT NULL;

CREATE TABLE proxy_history_tmp (
        id              number(20)              DEFAULT '0'     NOT NULL,
        itemid          number(20)              DEFAULT '0'     NOT NULL,
        clock           number(10)              DEFAULT '0'     NOT NULL,
        timestamp               number(10)              DEFAULT '0'     NOT NULL,
        source          nvarchar2(64)           DEFAULT ''      ,
        severity                number(10)              DEFAULT '0'     NOT NULL,
        value           nclob           DEFAULT ''      ,
        logeventid              number(10)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (id)
);


insert into proxy_history_tmp select * from proxy_history;
drop table proxy_history;

alter table proxy_history_tmp rename to proxy_history;

CREATE INDEX proxy_history_1 on proxy_history (clock);
CREATE TABLE regexps (
        regexpid                number(20)              DEFAULT '0'     NOT NULL,
        name            nvarchar2(128)          DEFAULT ''      ,
        test_string             nvarchar2(2048)         DEFAULT ''      ,
        PRIMARY KEY (regexpid)
);
CREATE INDEX regexps_1 on regexps (name);

CREATE INDEX rights_2 on rights (id);
alter table screens_items modify url             nvarchar2(255)          DEFAULT '';

alter table screens modify name            nvarchar2(255)          DEFAULT 'Screen';

alter table scripts modify name            nvarchar2(255)          DEFAULT '';
alter table scripts modify command         nvarchar2(255)          DEFAULT '';

CREATE INDEX services_1 on services (triggerid);

alter table services modify name            nvarchar2(128)          DEFAULT '';

alter table services_times modify note            nvarchar2(255)          DEFAULT '';
CREATE INDEX sessions_1 on sessions (userid, status);

alter table sessions modify sessionid               nvarchar2(32)           DEFAULT '';
alter table slideshows modify name            nvarchar2(255)          DEFAULT '';
alter table sysmaps_elements  modify label           nvarchar2(255)            DEFAULT ''      NOT NULL;
ALTER TABLE sysmaps_elements ADD iconid_maintenance number(20) DEFAULT '0' NOT NULL;

alter table sysmaps_elements modify url             nvarchar2(255)          DEFAULT '';
alter table sysmaps_links  add label           nvarchar2(255)            DEFAULT ''      NOT NULL;

alter table sysmaps_links modify color           nvarchar2(6)            DEFAULT '000000';
alter table sysmaps_link_triggers modify color           nvarchar2(6)            DEFAULT '000000';
ALTER TABLE sysmaps ADD highlight number(10) DEFAULT '1' NOT NULL;

alter table sysmaps modify name            nvarchar2(128)          DEFAULT '';
CREATE TABLE timeperiods (
        timeperiodid            number(20)              DEFAULT '0'     NOT NULL,
        timeperiod_type         number(10)              DEFAULT '0'     NOT NULL,
        every           number(10)              DEFAULT '0'     NOT NULL,
        month           number(10)              DEFAULT '0'     NOT NULL,
        dayofweek               number(10)              DEFAULT '0'     NOT NULL,
        day             number(10)              DEFAULT '0'     NOT NULL,
        start_time              number(10)              DEFAULT '0'     NOT NULL,
        period          number(10)              DEFAULT '0'     NOT NULL,
        start_date              number(10)              DEFAULT '0'     NOT NULL,
        PRIMARY KEY (timeperiodid)
);
alter table triggers modify expression              nvarchar2(255)          DEFAULT '';
alter table triggers modify description             nvarchar2(255)          DEFAULT '';
alter table triggers modify url             nvarchar2(255)          DEFAULT '';
alter table triggers modify comments                nvarchar2(2048)         DEFAULT '';
alter table triggers modify error           nvarchar2(128)          DEFAULT '';
CREATE TABLE user_history (
        userhistoryid           number(20)              DEFAULT '0'     NOT NULL,
        userid          number(20)              DEFAULT '0'     NOT NULL,
        title1          nvarchar2(255)          DEFAULT ''      ,
        url1            nvarchar2(255)          DEFAULT ''      ,
        title2          nvarchar2(255)          DEFAULT ''      ,
        url2            nvarchar2(255)          DEFAULT ''      ,
        title3          nvarchar2(255)          DEFAULT ''      ,
        url3            nvarchar2(255)          DEFAULT ''      ,
        title4          nvarchar2(255)          DEFAULT ''      ,
        url4            nvarchar2(255)          DEFAULT ''      ,
        title5          nvarchar2(255)          DEFAULT ''      ,
        url5            nvarchar2(255)          DEFAULT ''      ,
        PRIMARY KEY (userhistoryid)
);
CREATE UNIQUE INDEX user_history_1 on user_history (userid);

alter table users add rows_per_page           number(10)         DEFAULT 50      NOT NULL;

alter table users modify alias           nvarchar2(100)          DEFAULT '';
alter table users modify name            nvarchar2(100)          DEFAULT '';
alter table users modify surname         nvarchar2(100)          DEFAULT '';
alter table users modify passwd          nvarchar2(32)           DEFAULT '';
alter table users modify url             nvarchar2(255)          DEFAULT '';
alter table users modify lang            nvarchar2(5)            DEFAULT 'en_gb';
alter table users modify theme           nvarchar2(128)          DEFAULT 'default.css';
alter table users modify attempt_ip              nvarchar2(39)           DEFAULT '';
alter table usrgrp add api_access              number(10)         DEFAULT '0'     NOT NULL;
alter table usrgrp add debug_mode              number(10)         DEFAULT '0'     NOT NULL;

alter table usrgrp modify name            nvarchar2(64)           DEFAULT '';
alter table valuemaps modify name            nvarchar2(64)           DEFAULT '';

